{
          ,
       ,     RS232 

}
unit Utstrs;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, AdPort, OoMisc, IniFiles, ExtCtrls, Gauges, VBXCtrl,
  Gauge, AdTerm;

type
  TForm1 = class(TForm)
    ComPort: TApdComPort;
    StartBtn: TButton;
    Timer1: TTimer;
    InfoBox: TCheckBox;
    ErrBox: TCheckBox;
    SetsBox: TCheckBox;
    pInfoEd: TEdit;
    pErrEd: TEdit;
    pSetsEd: TEdit;
    HelpBox: TCheckBox;
    pHelpEd: TEdit;
    ApdTerminal1: TApdTerminal;
    procedure FormShow(Sender: TObject);
    procedure Msg(msgStr: string);
    procedure MsgErr(msgStr: string);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  {,    RS232}
  TxBuf: array [0..255] of char;
  RxBuf: array [0..255] of char;
  SendingStarted: boolean;
  {   ,    }
  tInfo, tErr, tSets, tHelp: integer;

const
  IniFileName: string = 'tstrs.ini';
  {,  }
  cmInfo: string = 'INFO';
  cmErr : string = 'ERRORS';
  cmSets: string = 'SETS';
  cmHelp: string = 'HELP';

implementation

{$R *.DFM}

procedure TForm1.Msg(msgStr: string);
{------------------------------------------
 *            *
 ------------------------------------------}
begin
  MessageDlg(msgStr, mtInformation, [mbOK], 0);
end;

procedure TForm1.MsgErr(msgStr: string);
{---------------------------------------------------
 *             *
 ---------------------------------------------------}
begin
  MessageDlg(msgStr, mtError, [mbOK], 0);
end;

procedure TForm1.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
  tmpStr: string;
  ItemCnt: byte;
begin
  { ini - }
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+IniFileName);
  with IniFile do begin
    {  }
    Form1.Left := ReadInteger('WindowPosition','Left',100);
    Form1.Top  := ReadInteger('WindowPosition','Top', 100);
    {   com-
        }
    ComPort.ComNumber := ReadInteger('ComPort','Com',  2);
    ComPort.Baud      := ReadInteger('ComPort','Speed',300);
  end;
  IniFile.Free;

  SendingStarted := FALSE;
  tInfo := 0;
  tErr  := 0;
  tSets := 0;
  tHelp := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
  ItemCnt: byte;
begin
  { ini - }
  IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+IniFileName);
  with IniFile do begin
    {  }
    WriteInteger('WindowPosition','Left',Form1.Left);
    WriteInteger('WindowPosition','Top', Form1.Top);
  end;
  IniFile.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  CmType: byte;
procedure Send (Cmd: string);
var
  BP: byte;
begin
  ComPort.FlushOutBuffer;
  { TxBuf}
  for BP := 0 to Length(Cmd)-1 do
    TxBuf[BP] := Cmd [BP+1];
  Inc(BP);
  TxBuf[BP] := char($0D);
  Inc(BP);
  ComPort.PutBlock(TxBuf,BP);
end;
begin
  {     ,
      }
  pInfoEd.Enabled := InfoBox.Checked;
  pErrEd .Enabled := ErrBox .Checked;
  pSetsEd.Enabled := SetsBox.Checked;
  pHelpEd.Enabled := HelpBox.Checked;

  if tInfo <> 0 then
    Dec(tInfo);
  if tErr  <> 0 then
    Dec(tErr);
  if tSets <> 0 then
    Dec(tSets);
  if tHelp <> 0 then
    Dec(tHelp);

  if SendingStarted then begin
    StartBtn.Caption := '  :';
    if (tInfo = 0) and
       (tErr  = 0) and
       (tSets = 0) and
       (tHelp = 0) then begin
       CmType := Random (4);
       case CmType of
       0{INFO}:   if InfoBox.Checked then
                    begin
                      tInfo := StrToInt(pInfoEd.Text)*10;
                      Send (cmInfo);
                    end;
       1{ERRORS}: if ErrBox.Checked then
                    begin
                      tErr  := StrToInt(pErrEd .Text)*10;
                      Send (cmErr);
                    end;
       2{SETS}:   if SetsBox.Checked then
                    begin
                      tSets := StrToInt(pSetsEd.Text)*10;
                      Send (cmSets);
                    end;
       3{HELP}:   if HelpBox.Checked then
                    begin
                      tHelp := StrToInt(pHelpEd.Text)*10;
                      Send (cmHelp);
                    end;
       end;
    end;
  end else begin
    StartBtn.Caption := '  :';
  end;
end;

procedure TForm1.StartBtnClick(Sender: TObject);
begin
  SendingStarted := not SendingStarted;
end;

end.
